from machine import Pin,SPI,PWM
import framebuf
import time
import random
from array import array
import lab_felder

BL = 13
DC = 8
RST = 12
MOSI = 11
SCK = 10
CS = 9


class LCD_1inch14(framebuf.FrameBuffer):
    def __init__(self):
        self.width = 240
        self.height = 135
        
        self.cs = Pin(CS,Pin.OUT)
        self.rst = Pin(RST,Pin.OUT)
        
        self.cs(1)
        self.spi = SPI(1)
        self.spi = SPI(1,1000_000)
        self.spi = SPI(1,10000_000,polarity=0, phase=0,sck=Pin(SCK),mosi=Pin(MOSI),miso=None)
        self.dc = Pin(DC,Pin.OUT)
        self.dc(1)
        self.buffer = bytearray(self.height * self.width * 2)
        super().__init__(self.buffer, self.width, self.height, framebuf.RGB565)
        self.init_display()
        
        self.red   =   0x07E0
        self.green =   0x001f
        self.blue  =   0xf800
        self.white =   0xffff
        
    def write_cmd(self, cmd):
        self.cs(1)
        self.dc(0)
        self.cs(0)
        self.spi.write(bytearray([cmd]))
        self.cs(1)

    def write_data(self, buf):
        self.cs(1)
        self.dc(1)
        self.cs(0)
        self.spi.write(bytearray([buf]))
        self.cs(1)

    def init_display(self):
        """Initialize dispaly"""  
        self.rst(1)
        self.rst(0)
        self.rst(1)
        
        self.write_cmd(0x36)
        self.write_data(0x70)

        self.write_cmd(0x3A) 
        self.write_data(0x05)

        self.write_cmd(0xB2)
        self.write_data(0x0C)
        self.write_data(0x0C)
        self.write_data(0x00)
        self.write_data(0x33)
        self.write_data(0x33)

        self.write_cmd(0xB7)
        self.write_data(0x35) 

        self.write_cmd(0xBB)
        self.write_data(0x19)

        self.write_cmd(0xC0)
        self.write_data(0x2C)

        self.write_cmd(0xC2)
        self.write_data(0x01)

        self.write_cmd(0xC3)
        self.write_data(0x12)   

        self.write_cmd(0xC4)
        self.write_data(0x20)

        self.write_cmd(0xC6)
        self.write_data(0x0F) 

        self.write_cmd(0xD0)
        self.write_data(0xA4)
        self.write_data(0xA1)

        self.write_cmd(0xE0)
        self.write_data(0xD0)
        self.write_data(0x04)
        self.write_data(0x0D)
        self.write_data(0x11)
        self.write_data(0x13)
        self.write_data(0x2B)
        self.write_data(0x3F)
        self.write_data(0x54)
        self.write_data(0x4C)
        self.write_data(0x18)
        self.write_data(0x0D)
        self.write_data(0x0B)
        self.write_data(0x1F)
        self.write_data(0x23)

        self.write_cmd(0xE1)
        self.write_data(0xD0)
        self.write_data(0x04)
        self.write_data(0x0C)
        self.write_data(0x11)
        self.write_data(0x13)
        self.write_data(0x2C)
        self.write_data(0x3F)
        self.write_data(0x44)
        self.write_data(0x51)
        self.write_data(0x2F)
        self.write_data(0x1F)
        self.write_data(0x1F)
        self.write_data(0x20)
        self.write_data(0x23)
        
        self.write_cmd(0x21)

        self.write_cmd(0x11)

        self.write_cmd(0x29)

    def show(self):
        self.write_cmd(0x2A)
        self.write_data(0x00)
        self.write_data(0x28)
        self.write_data(0x01)
        self.write_data(0x17)
        
        self.write_cmd(0x2B)
        self.write_data(0x00)
        self.write_data(0x35)
        self.write_data(0x00)
        self.write_data(0xBB)
        
        self.write_cmd(0x2C)
        
        self.cs(1)
        self.dc(1)
        self.cs(0)
        self.spi.write(self.buffer)
        self.cs(1)
  
pwm = PWM(Pin(BL))
pwm.freq(1000)
pwm.duty_u16(32768)#max 65535
LCD = LCD_1inch14()
LCD.fill(LCD.blue)
LCD.hline(0,0,240,LCD.white)
LCD.vline(0,0,135,LCD.white)
LCD.vline(239,1,135,LCD.white)
LCD.hline(1,134,240,LCD.white)
LCD.text("Pico - Labyrinth",50,10,LCD.white)
LCD.text("by gebmedia",70,120,LCD.white)
LCD.fill_rect(40,30,160,80,LCD.white)
LCD.rect(45,35,150,70,0x0000)
LCD.rect(44,36,150,70,0x0000)
LCD.text("A-Button: Start",50,45,LCD.blue)
LCD.text("Finde den Ausgang",50,65,LCD.blue)
LCD.text("und sammle die",50,80,LCD.blue)
LCD.text("roten Punkte ein.",50,95,LCD.blue)
LCD.show()
  
def init_screen(pos,xstart,ystart,x,y):
    LCD.fill(LCD.blue)
    LCD.show()
    LCD.vline(0,0,135,LCD.white)
    LCD.vline(239,1,135,LCD.white)
    pos=0
    lab_felder.labyrinth(LCD,Liste,pos,xstart,ystart,x,y)
    punkte_setzen(yp)


def punkte_setzen(yp):
    xp = random.randint(1,10)*20
    if yp < 64:
        yp = 2*yp + 7
        LCD.fill_rect(xp+5,yp,8,8,LCD.red)
        for zeile in range(8):
            for spalte in range(8):
                Liste[zeile+xp + (spalte+yp)*240] = 0x07E0
        fobj=open("punkte.txt", 'w')
        fobj.write(str(xp) + "\n")
        fobj.write(str(yp) + "\n")
        fobj.close()
    
def punkte_loeschen(punkte):
    fobj=open("punkte.txt", 'r')
    xp = int(fobj.readline())
    yp = int(fobj.readline())
    fobj.close()
    LCD.fill_rect(xp+5,yp,8,8,LCD.blue)
    for zeile in range(8):
        for spalte in range(8):
            Liste[zeile+xp + (spalte+yp)*240] = 0x0000
    LCD.fill_rect(200,1,40,20,LCD.white)
    LCD.text(str(punkte),205,5,LCD.blue)
    punkte_setzen(yp)

def crash():
    LCD.fill_rect(50,30,160,80,LCD.white)
    LCD.rect(54,35,150,70,0x0000)
    LCD.text("Crash !!!",70,45,LCD.blue)
    LCD.text("Spiel zu Ende",70,65,LCD.blue)
    LCD.text("Press A or B",70,85,LCD.blue)
    LCD.show()


keyA = Pin(15,Pin.IN,Pin.PULL_UP)
keyB = Pin(17,Pin.IN,Pin.PULL_UP)
key2 = Pin(2 ,Pin.IN,Pin.PULL_UP) #上
key3 = Pin(3 ,Pin.IN,Pin.PULL_UP)#中
key4 = Pin(16 ,Pin.IN,Pin.PULL_UP)#左
key5 = Pin(18 ,Pin.IN,Pin.PULL_UP)#下
key6 = Pin(20 ,Pin.IN,Pin.PULL_UP)#右

Liste = bytearray(240 * 135)
pos =0
x=0
y=0
yp=0
xstart=0
ystart=0
start=0


while(1):
    #if(key3.value() == 0): #crtl
    #    print(x," , ",y)
    if(keyA.value() == 0) or (keyB.value() == 0) :
        start=1
        punkte=0
        init_screen(pos,xstart,ystart,x,y)
        fobj=open("daten.txt", 'r')
        x = int(fobj.readline())
        xe = int(fobj.readline())
        y = int(fobj.readline())
        fobj.close()
        LCD.fill_rect(x,y,6,6,LCD.white)
        LCD.show()
    
    if start == 1:    
        if(key2.value() == 0): #up
            pos= x+y*240
            if Liste[pos] == 0:
                LCD.fill_rect(x,y,6,6,LCD.white)
                LCD.show()
                y = y - 1
                LCD.fill_rect(x,y+1,6,6,LCD.blue)
                punkte = punkte -1
            else:
                if Liste[pos] == 255:
                    crash()
                    start=0
                else:
                    punkte = punkte + 25
                    punkte_loeschen(punkte)
                    LCD.fill_rect(x,y,6,6,LCD.green)
                    LCD.show()
                
        if(key5.value() == 0):#down
            pos= x+y*240
            if Liste[pos] == 0:
                LCD.fill_rect(x,y,6,6,LCD.white)
                LCD.show()
                y = y + 1
                LCD.fill_rect(x,y-1,6,6,LCD.blue)
                punkte = punkte + 3
            else:
                if Liste[pos] == 255:
                    crash()
                    start=0
                else:
                    punkte = punkte + 25
                    punkte_loeschen(punkte)
                    LCD.fill_rect(x,y,6,6,LCD.green)
                    LCD.show()
            
        if(key4.value() == 0):#left
            pos= x+y*240
            if Liste[pos] == 0:
                LCD.fill_rect(x,y,6,6,LCD.white)
                LCD.show()
                x = x - 1
                LCD.fill_rect(x+1,y,6,6,LCD.blue)
                punkte = punkte + 3
            else:
                if Liste[pos] == 255:
                    crash()
                    start=0
                else:
                    punkte = punkte + 25
                    punkte_loeschen(punkte)
                    LCD.fill_rect(x,y,6,6,LCD.green)
                    LCD.show()
            
        if(key6.value() == 0):#right
            pos= x+y*240
            if Liste[pos] == 0: 
                LCD.fill_rect(x,y,6,6,LCD.white)
                LCD.show()
                x = x + 1
                LCD.fill_rect(x-1,y,6,6,LCD.blue)
                punkte = punkte - 1
            else:
                if Liste[pos] == 255:
                    crash()
                    start=0
                else:
                    punkte = punkte + 25
                    punkte_loeschen(punkte)
                    LCD.fill_rect(x,y,6,6,LCD.green)
                    LCD.show()
        
        if y > 129 and (x > xe and x < (xe + 20)):
            LCD.fill_rect(200,1,40,20,LCD.white)
            LCD.text(str(punkte),205,5,LCD.blue)
            LCD.fill_rect(50,30,160,80,LCD.white)
            LCD.rect(54,35,150,70,0x0000)
            LCD.text("Ziel erreicht.",70,45,LCD.blue)
            LCD.text("mit "+str(punkte)+" Punkten",70,65,LCD.blue)
            LCD.text("Press A or B",70,85,LCD.blue)
            LCD.show()
            start=0